package com.gic.haoban.manage.service.service.out.impl;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.api.base.commons.Page;
import com.gic.commons.util.EntityUtil;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.common.utils.UuidUtil;
import com.gic.haoban.manage.api.dto.DepartmentDTO;
import com.gic.haoban.manage.api.dto.DictDTO;
import com.gic.haoban.manage.api.dto.HelpDTO;
import com.gic.haoban.manage.api.service.DictApiService;
import com.gic.haoban.manage.api.service.HelpApiService;
import com.gic.haoban.manage.service.dao.mapper.DictMapper;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanHelpMapper;
import com.gic.haoban.manage.service.entity.TabHaobanDict;
import com.gic.haoban.manage.service.entity.TabHaobanHelp;
import com.github.pagehelper.PageHelper;

import java.util.List;

/**
 * Created by tgs on 2020/2/9.
 */
@Service
public class HelpApiServiceImpl implements HelpApiService{
	@Autowired
	private TabHaobanHelpMapper tabHaobanHelpMapper;
	@Override
	public int saveHelp(HelpDTO dto) {
		if(StringUtils.isBlank(dto.getHelpId())){
			//空，则新增
			dto.setHelpId(UuidUtil.randomUUID());
			TabHaobanHelp tab = EntityUtil.changeEntity(TabHaobanHelp.class, dto);
			TabHaobanHelp tab1 = tabHaobanHelpMapper.selectByHelpTitle(dto.getHelpTitle());
			if(tab1!=null){
				return 8;
			}
			tabHaobanHelpMapper.insert(tab);
		}else{
			TabHaobanHelp tab = EntityUtil.changeEntity(TabHaobanHelp.class, dto);
			tabHaobanHelpMapper.updateByPrimaryKeySelective(tab);
		}	
		return 1;
	}

	@Override
	public HelpDTO findOneHelp(String helpId) {
		TabHaobanHelp tab = tabHaobanHelpMapper.selectByPrimaryKey(helpId);
		if(tab == null){
			return null;
		}
		HelpDTO dto = EntityUtil.changeEntity(HelpDTO.class, tab);
		return dto;	
	}

	@Override
	public Page<HelpDTO> pageList(BasePageInfo pageInfo) {
		PageHelper.startPage(pageInfo.getPageNum(), pageInfo.getPageSize());
		return PageUtil.changePageHelperToCurrentPage( tabHaobanHelpMapper.pageList(),HelpDTO.class);
	}

	@Override
	public void deleteOne(String helpId) {
		tabHaobanHelpMapper.deleteByPrimaryKey(helpId);		
	}

}
